`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: Andrew Gray
// 
// Create Date: 09/20/2022 08:50:17 AM
// Design Name: 
// Module Name: pmodALS
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// Control the pmod function for testing
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module pmodALS(
    input sclk,
    input cs_n,
    input [7:0] next,
    output reg [14:0] sdata
    );
    
   // parameter Tacc=40;
    //3 leading 0s, 
   
    always @(negedge sclk) begin
      
      if(cs_n==0)begin //wait for cs to be 0
        
        sdata[14:12]<=3'b000; //3 leading 0s
        sdata[11:4]<=next; //given next value
        sdata[3:0]<=4'b0000; //4 lagging 0s
      
      end
     
    end

    
endmodule
