`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 11/07/2023 08:00:15 PM
// Design Name: 
// Module Name: solver
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module solver #(parameter VARS=3, LEN=8) (
   
    input [6:0] Co_1, Co_2, Co_3, Co_4, Co_5,/* Co_6, Co_7, Co_8, Co_9, Co_10,*/
    output reg [LEN:0] terms_f 
    );
    
    reg [2:0] terms=3'b000;
    reg solved;
    reg X1=1'b0;
    reg X2=1'b0;
    reg X3=1'b0;
    reg result_1, result_2, result_3, result_4, result_5, result_6, result_7, result_8, result_9, result_10;
    //X1 + X2 + X3 + X1X2 + X2X3 + X3X4 + Rest = RHS
    //7 Terms + Rest + RHS = 8 Bit long Equations
    
    reg X1X2 ;
    reg X2X3;
    reg X3X1;
    integer x;
     integer MAX=2**VARS;
     always @(*) begin
  for (x=0; x<MAX; x=x+1) begin
   X1=terms[2];
   X2=terms[1];
   X3=terms[0];
   X1X2 = X1 & X2;
     X2X3 = X2 & X3;
     X3X1 = X1 & X3;
     result_1 = (X1 & Co_1[6]) ^ (X2 & Co_1[5]) ^ (X3 & Co_1[4])  ^(X1X2 & Co_1[3]) ^(X2X3 & Co_1[2]) ^(X3X1 & Co_1[1]) ;
      result_2 = (X1 & Co_2[6]) ^ (X2 & Co_2[5]) ^ (X3 & Co_2[4])  ^(X1X2 & Co_2[3]) ^(X2X3 & Co_2[2]) ^(X3X1 & Co_2[1]) ;
      result_3= (X1 & Co_3[6]) ^ (X2 & Co_3[5]) ^ (X3 & Co_3[4])  ^(X1X2 & Co_3[3]) ^(X2X3 & Co_3[2]) ^(X3X1 & Co_3[1]);
        result_4= (X1 & Co_4[6]) ^ (X2 & Co_4[5]) ^ (X3 & Co_4[4])  ^(X1X2 & Co_4[3]) ^(X2X3 & Co_4[2]) ^(X3X1 & Co_4[1]);
   result_5= (X1 & Co_5[6]) ^ (X2 & Co_5[5]) ^ (X3 & Co_5[4])  ^(X1X2 & Co_5[3]) ^(X2X3 & Co_5[2]) ^(X3X1 & Co_5[1]);
  /*  result_6 = (X1 & Co_6[6]) ^ (X2 & Co_6[5]) ^ (X3 & Co_6[5])  ^(X1X2 & Co_6[4]) ^(X2X3 & Co_6[3]) ^(X3X1 & Co_6[2]);
        result_7= (X1 & Co_7[6]) ^ (X2 & Co_7[5]) ^ (X3 & Co_9[4])  ^(X1X2 & Co_9[3]) ^(X2X3 & Co_9[2]) ^(X3X1 & Co_9[1]);
      result_8= (X1 & Co_8[6]) ^ (X2 & Co_8[5]) ^ (X3 & Co_8[4])  ^(X1X2 & Co_8[3]) ^(X2X3 & Co_8[2]) ^(X3X1 & Co_8[1]);
    result_9= (X1 & Co_9[6]) ^ (X2 & Co_9[5]) ^ (X3 & Co_9[4])  ^(X1X2 & Co_9[3]) ^(X2X3 & Co_9[2]) ^(X3X1 & Co_9[1]);
   result_10= (X1 & Co_10[6]) ^ (X2 & Co_10[5]) ^ (X3 & Co_10[4])  ^(X1X2 & Co_10[3]) ^(X2X3 & Co_10[2]) ^(X3X1 & Co_10[1]);
     */
     solved = ( (result_1 == Co_1[0])
     & (result_2 == Co_2[0]) 
    &(result_3 == Co_3[0])
     &(result_4 == Co_4[0])
     &(result_5 == Co_5[0])
  /*   &(result_6 == Co_6[0])
     & (result_7 == Co_7[0])
      &(result_8 == Co_8[0])
      & (result_9 == Co_9[0])
      &(result_10 == Co_10[0])*/)
       ? 1'b1 : 1'b0;
      if(solved==1'b1) begin
       terms_f={terms_f, terms};
      terms_f={terms_f, 1'b0};
      end
   //   else begin
 //     terms_f={terms_f, 3'bZZZ};
 //     end
      terms=terms+1'b1;
    end
    end
endmodule