`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 12/12/2023 10:46:11 PM
// Design Name: 
// Module Name: solver5
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module solver5 #(parameter VARS=5, LEN=12) (
   
    input [13:0] Co_1, Co_2, Co_3,/* Co_4, Co_5, Co_6, Co_7, Co_8, Co_9, Co_10,*/
    output reg [LEN:0] terms_f 
    );
    
    reg [4:0] terms=5'b00000;
    reg solved;
    reg X1=1'b0;
    reg X2=1'b0;
    reg X3=1'b0;
    reg X4=1'b0;
    reg X5=1'b0;
    reg result_1, result_2, result_3, result_4, result_5, result_6, result_7, result_8, result_9, result_10;
    //X1 + X2 + X3 + X1X2 + X2X3 + X3X4 + Rest = RHS
    //7 Terms + Rest + RHS = 8 Bit long Equations
    
 
      reg X1X2 ;
    reg X1X3 ;
    reg X1X4 ;
    reg X1X5;
    reg X2X3;
    reg X2X4 ;
    reg X2X5;
    reg X3X4;
    reg X3X5 ;
    reg X4X5 ;
    integer x;
     integer MAX=2**VARS;
     always @(*) begin
  for (x=0; x<MAX; x=x+1) begin
   X1=terms[4];
   X2=terms[3];
   X3=terms[2];
   X4=terms[1];
   X5=terms[0];
   X1X2 = X1 & X2;
     X1X3 = X1 & X3;
     X1X4 = X1 & X4;
     X1X5 = X1 & X5;
     X2X3 = X2 & X3;
     X2X4 = X2 & X4;
     X2X5 = X2 & X5;
     X3X4 = X3 & X4;
     X3X5 = X3 & X5;
     X4X5 = X4 & X5;
  result_1 = (X1 & Co_1[13]) ^ (X2 & Co_1[12]) ^(Co_1[11]&X3)^ (X4 & Co_1[10])^(Co_1[9]&X5)
  ^(Co_1[8]&X1X3)^(Co_1[7]&X1X4)^(Co_1[6]&X1X5)^(Co_1[5]&X2X3)^(Co_1[4]&X2X4)^(Co_1[3]&X2X5)^(Co_1[2]&X3X4)^(Co_1[1]&X3X5)^(Co_1[0]&X4X5);
     result_2 = (X1 & Co_2[13]) ^ (X2 & Co_2[12]) ^(Co_2[11]&X3)^ (X4 & Co_2[10])^(Co_2[9]&X5)
  ^(Co_2[8]&X1X3)^(Co_2[7]&X1X4)^(Co_2[6]&X1X5)^(Co_2[5]&X2X3)^(Co_2[4]&X2X4)^(Co_2[3]&X2X5)^(Co_2[2]&X3X4)^(Co_2[1]&X3X5)^(Co_2[0]&X4X5);
   result_3 = (X1 & Co_3[13]) ^ (X2 & Co_3[12]) ^(Co_3[11]&X3)^ (X4 & Co_3[10])^(Co_3[9]&X5)
  ^(Co_3[8]&X1X3)^(Co_3[7]&X1X4)^(Co_3[6]&X1X5)^(Co_3[5]&X2X3)^(Co_3[4]&X2X4)^(Co_3[3]&X2X5)^(Co_3[2]&X3X4)^(Co_3[1]&X3X5)^(Co_3[0]&X4X5);
       
     solved = ( (result_1 == Co_1[0])&(result_2==Co_2[0])&(result_3==Co_3[0]))
       ? 1'b1 : 1'b0;
      if(solved==1'b1) begin
       terms_f={terms_f, terms};
      terms_f={terms_f, 1'b0};
      end
   //   else begin
 //     terms_f={terms_f, 3'bZZZ};
 //     end
      terms=terms+1'b1;
    end
    end
endmodule
