`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/31/2024 02:40:13 PM
// Design Name: 
// Module Name: Xor_transpose
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Xor_transpose#(parameter integer EQ_LEN=34, parameter integer NUM_EQs=5, parameter integer window=34)(
input reg [EQ_LEN:0] matrixs [0:(NUM_EQs-1)],
output reg [4:0] NUM_EQi,
output reg [NUM_EQs:0][NUM_EQs:0] result [4:0]
    );
    /*
    matrix for number of differences, array of integersfor eqch equation
 Input:2d matrix full of terms 
 parameters: number of equations and length of equations to build the 2d matrix 
 window: number of terms currently active
 output: 2d matrix 
 
    
    */
    reg [7:0] xDiff;
    
integer i,x, t;
  initial begin
      NUM_EQi=NUM_EQs;
   
      for(i=0; i<NUM_EQs; i=i+1) begin
        for(x=0;x<NUM_EQs;x=x+1) begin      
         xDiff=7'd0;
        for(t=0; t<window; t=t+1) begin    
        if(i==x) begin
         result[i][x]=7'd0;
        end //if
            xDiff=xDiff+(matrixs[i][t]^matrixs[x][t]);
                   
        end //t
        result[i][x]=xDiff;
        end//x
       
      end//i
  end
endmodule
/*output looks like this without the titles and no spaces
  0    1    2
0 0000 0010 0001
1 0010 0000 0001
2 0001 0001 0000
       
       
       printed like 
        $display("  0    1    2");
 $display("0 %b %b %b", result[0][0], result[0][1], result[0][2]);
 $display("1 %b %b %b", result[1][0],  result[1][1],  result[1][2]);
  $display("2 %b %b %b", result[2][0], result[2][1], result[2][2]);
  $display("\n %b", num_eqi);
  
  
  call Xor_transpose #(.NUM_EQs(3)) test(.matrixs(matrixs2),.NUM_EQi(num_eqi),.result(result));
  can change one parameter at a time
        end*/