`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 02/20/2024 10:36:34 PM
// Design Name: 
// Module Name: case3_10
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module case3_10(
    input reg [6:0] coeff,
    output reg [11:0] out
); 

// xaxb + xcxd + xexf
// 3 independent quads

always@(*)
begin
    out = 12'b0; 
    case(coeff)
    7'b0000111:
        begin
        // "0000111":[("0000111",1),("00011",0)],
        out = 12'b000011100011;
        end
    7'b0001110:
        begin
        out = 12'b000111000110;
        end
    7'b0010101:
        begin
        out = 12'b001010101001;
        end
    7'b0011100:
        begin
        out = 12'b001110001100;
        end
    7'b1000111:
        begin
        out = 12'b100011110011;
        end
    7'b1001110:
        begin
        out = 12'b100111010110;
        end
    7'b1010101:
        begin
        out = 12'b101010111001;
        end
    7'b1011100:
        begin
        out = 12'b101110011100;
        end
    endcase
end
endmodule