module case3_8(
    input reg [6:0] coeff,
    output reg [6:0] out
);

// xaxb + xaxc + xaxd
// 3 mutually dependent quads

always@(*)
begin
    out = 7'b0; 
    case(coeff)
    7'b0000111:
        begin
        //("0000111",1),("","",0)
        out = 7'b0000111;
        end
    7'b0001110:
        begin
        out = 7'b0001110;
        end
    7'b0010101:
        begin
        out = 7'b0010101;
        end
    7'b0011100:
        begin
        out = 7'b0011100;
        end
    7'b1000111:
        begin
        out = 7'b1000111;
        end
    7'b1001110:
        begin
        out = 7'b1001110;
        end
    7'b1010101:
        begin
        out = 7'b1010101;
        end
    7'b1011100:
        begin
        out = 7'b1011100;
        end
    endcase
end
endmodule