`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/16/2024 11:44:44 PM
// Design Name: 
// Module Name: frankenstein
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module eq_check(

);
//constants
  reg [0:2][0:1] Zcoeff = {{1'b0,1'b0}, {1'b1,1'b0}, {1'b0,1'b1}};       // pairs of solution that for Zeros 
  reg [4:0] Zcoeff2=5'b001001;
  reg P = {1'b1,1'b0};                  //     # Any Pair; Don't Care
  reg ONE = {1'b1,1'b1};
 wire [35:0] EQ8_1=36'bX01010101010101010101010101010101010;
 wire [35:0] EQ8_2=36'bX01010101010101010101010101010101010;
 wire [35:0] EQ8_3=36'bX01010101010101010101010101010101010;
 wire [35:0] matrixs [0:2]={EQ8_1,EQ8_2, EQ8_3};
 integer EQ_LEN=35;
//TODO i think we can delete assumption values in the LUT
/* might have to unabstract this so it might look like a cry for help*/
function xors([EQ_LEN:0] x1, [EQ_LEN:0] x2);
 /*
        xors two array

        @param eq1: Array of binary values
        @param eq2: Array of binary values

        :return: Array xor of eq1 and eq2
    */
    x1={x1,x1^x2};
endfunction

/*        transpose matrix and xor 

        @param original: 2D Matrix/Array

        :return: 2D Array of xor between original and transposed array */

function bit[:0] because_it_is(transformed_eq, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2, assumed_val); 
   
    if(assumed_val==0) 
    begin 
        // assume xa = 0 
        sol_zero = transformed_eq[1]
        // Literally its just adding RHS to form new codes 
        new_code = sol_zero[0] + str(RHS1) + str(RHS2)
    end 
    else
    begin 
        // assume xa = 1
        sol_one = transformed_eq[0]
        // TODO check null here because :D
        new_eq1 = sol_one[0]        
        if (len(sol_one) == 3)
            new_eq2 = sol_one[1]   
        else
            new_eq2 = ""  
        new_code = constructing_new_RHS(RHS1, RHS2, arbitrary_rest1, arbitrary_rest2, new_eq1, new_eq2)
    end   

    return new_code

endfunction


// accessing rest from 3_to_2 and making new RHS to form the codes
function constructing_new_RHS(RHS1, RHS2, R1, R2, eq1, eq2=""); 
    
    // get new rest from equations
    nR1 = (R1 + int(eq1[0])) %2
    if eq2: 
        nR2 = (R2 + int(eq2[0])) %2
        eq = eq1[1:] + eq2[1:]
    else: 
        nR2 = (R2 + int(eq1[1]) )%2
        eq = eq1[1:]
    
    // if not the same rest we are going to XOR it to RHS because we can
    if(nR1 != nR2): 
        // xor mod add 
        RHS1 = (RHS1 + nR1) %2 
        RHS2 = (RHS2 + nR2) %2 
        // set new rest 
        nR1 = 0
        nR2 = 0
    
    // form new code
    cruel_summer = str(nR1) + eq + str(RHS1) + str(RHS2)
    return cruel_summer 

endfunction


endmodule