`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 02/22/2024 10:31:43 AM
// Design Name: 
// Module Name: sol_varying_three
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module sol_varying_three
#(parameter integer EQ_LEN=34, parameter integer NUM_EQs=5, parameter integer window=34, parameter integer i=4)(
//input reg [EQ_LEN:0] matrixs [0:2],
input reg [6:0] coeffs,
input clk,
input reset,
input reg [10:0] L1,
input reg [10:0] L2,
input reg [10:0] L3,
input integer first,
input integer second,
output reg [10:0] solutions,
output integer outputnum
    );
    
    
 //reg [6:0] coeffs;
 reg [10:0] out1;
 integer status=0;
 reg [6:0] out2;
 reg [8:0] out3;
 reg [10:0] out4;
 reg [5:0] out5;
 reg [8:0] out6;
 reg [10:0] out7;
 reg [6:0] out8;
 reg [9:0] out9;
parameter integer quad_bound=5;
 reg [11:0] out10;
 reg [9:0] out11;
 reg [9:0] out12;
 reg [10:0] out13;
 reg twelver=0; //used to set status to 12, weird if statement rules
//parameter integer oness [5:0]={1,6,7,8,9}; //see below at expananation
// integer twoss [5:0]={ 2,6,10,11,12};
//   integer threess [5:0]={3,7,10,13,14};
 //  integer fourss [5:0]={4,8,11,13,15};
 //  integer fivess [5:0]={5,9,12,14,15};
 //assign statements for making coeffs
/* assign eq1=matrixs[first];
  assign eq2=matrixs[second];
   assign eq1co1=eq1[L1];
  assign eq2co1=eq2[L1];
  assign eq1co2=eq1[L2];
  assign eq2co2=eq2[L2];
 assign eq1co3=eq1[L1];
 assign  eq2co3=eq2[L3];
  assign RHS2=eq2[0];
 assign  RHS1=eq1[0];
 assign  coeffs={eq1co1,eq2co1,eq1co2,eq2co2,eq1co3,eq2co3, RHS1, RHS2};
 */
 integer temp; //for swapping var
 //instantiate all possible modules
    case3_1 one(coeffs, out1);
    case3_2 two(coeffs, out2);
    case3_3 three(coeffs, out3);
    case3_4 four(coeffs, out4);
    case3_5 five(coeffs, out5);
    case3_6 six(coeffs, out6);
    case3_7 seven(coeffs, out7);
    case3_8 eight(coeffs, out8);
    case3_9 nine (coeffs, out9);
    case3_10 ten(coeffs, out10);
    case3_11 eleven (coeffs, out11);
    case3_12 twelve (coeffs, out12);
    case3_13 thirteen (coeffs, out13);
    /* STILL NEED
       elif not vars_A.isdisjoint(vars_B):
            if len(vars_A) == 1:
                #xa + xaxb + xcxd
                status = 6
            else:
                #check if A and C have variables in common
                if status == 3:
                    #xaxb + xaxc + xbxd, may need other case tho
                    status = 12
                else:
                    #xaxb + xaxc + xdxe
                    status = 9*/
 (* DONT_TOUCH = "yes" *) always@(*) begin
 $display("testf");
//getting coeffecients
 
   // dep single vars > indep single vars > dependent quads > indep quads
   //variable swaps if out of order
   if(L1>L2) begin
     L2=temp;
     L2=L1;
     L1=temp;
   end
   if(L2>L3) begin
     L3=temp;
     L3=L2;
     L2=temp;
   end
   if(L1>L3) begin
     L1=temp;
     L1=L3;
     L3=temp;
   end
   /* The below math is for 5 variables. This will need to be adjusted manually as 
   variables expand
   X1 starts at 0 with an increment by one from there
      X1; X2; X3; X4; X5; X1X2 ;X1X3 ;X1X4 ;X1X5;X2X3;X2X4 ;X2X5; X3X4; X3X5 ;X4X5 ;
  0   1   2   3   4    5   6     7    8     9    10   11     12    13   14     15
      this is used to determine when variables are dependent
      the integers L1, L2, and L3 are used for locations and must be in order
   */
   status=1; //xa+xb+xc, assumed first
   
    //case 1, variable in all 3 differences. This will have to be manually done
   //1: 1,6,7,8,9
   //2: 2,6,10,11,12
   //3:3,7,10,13,14
   //4:4,8,11,13,15
   //5:5,9,12,14,15
  
if(L3>quad_bound) begin //x?+x?+x?x?
  $display("L3>5");
   //vars A and vars C have term(s) in common,
 if((L3 inside {1,6,7,8,9} && L1 inside {1,6,7,8,9}) ||
    (L3 inside { 2,6,10,11,12} && L1 inside { 2,6,10,11,12})|| 
    (L3 inside {3,7,10,13,14} && L1 inside {3,7,10,13,14}) ||
    (L3 inside {4,8,11,13,15} && L1 inside {4,8,11,13,15}) ||
    (L3 inside {5,9,12,14,15} && L1 inside {5,9,12,14,15})) begin
    $display("yesy ");
      //#Current equation is now xa?? + ? + xax?, assume xa and xc to be indep.
   status=3;
      if((L3 inside {1,6,7,8,9} && L2 inside {1,6,7,8,9}) ||
     (L3 inside { 2,6,10,11,12} && L2 inside { 2,6,10,11,12})|| 
     (L3 inside {3,7,10,13,14} && L2 inside {3,7,10,13,14}) ||
     (L3 inside {4,8,11,13,15} && L2 inside {4,8,11,13,15}) ||
     (L3 inside {5,9,12,14,15} && L2 inside {5,9,12,14,15})) begin
       //#Current equation is xaxb + xaxc + xaxd or xa + xb + xaxb
       if(L1<quad_bound && L2<quad_bound) begin
         // #xa + xb + xaxb
           status = 2;
           $display("status=2");
       end //quad_bound L1 L2
       else if(L1<quad_bound) begin
       //xa + xaxb + xaxc
         status = 5;
       end 
     else begin
       case(L1)
   //#xaxb + xbxc + xcxa
    1:begin if ((L2==6 || L2== 7|| L2==8 ||L2==9)&&(L3==6 || L3== 7|| L3==8 ||L3==9)) begin
            status=11;
            $display("status=11");
             end           
      end
    2:begin if ((L2==6 || L2== 10|| L2==11 ||L2==12)&&(L3==6 || L3== 10|| L3==11 ||L3==12)) begin
            status=11; end
    
    end
    3: begin if ((L2==7 || L2== 10|| L2==13 ||L2==14)&&(L3==7 || L3== 10|| L3==13 ||L3==14)) begin
            status=11; end end
    4: begin if ((L2==8 || L2== 11|| L2==13 ||L2==15)&&(L3==8 || L3== 11|| L3==13 ||L3==15)) begin
            status=11; end end
    5: begin if ((L2==9 || L2== 12|| L2==14 ||L2==15)&&(L3==9 || L3== 12|| L3==14 ||L3==15)) begin
            status=11; end end   
    endcase
    if(status!=11) begin
      status=8;     // #xaxb + xaxc + xaxd
    end //status!=11
     end //whole else statement
      end //L3 and L2 same array
    end //L3 and L1 same array
    else if((L1 inside {1,6,7,8,9} && L2 inside {1,6,7,8,9}) ||
     (L1 inside { 2,6,10,11,12} && L2 inside { 2,6,10,11,12})|| 
     (L1 inside {3,7,10,13,14} && L2 inside {3,7,10,13,14}) ||
     (L1 inside {4,8,11,13,15} && L2 inside {4,8,11,13,15}) ||
     (L1 inside {5,9,12,14,15} && L2 inside {5,9,12,14,15})) begin
      if(L1<quad_bound) begin
        // #xa + xaxb + xcxd
                status = 6;
      end //L1<quad
     else begin
      if(status==3) begin
        twelver=1;
      end //status 3
      else begin
        status=9;
      end
     end// twelver
    end //L1 and L2 connected
    if(status!=8 && status!=11 && status!=5 &&status!=2 &&status!=3) begin
     // #xa + xbxc + xbxd
      //          #no table
                status = 13;
    end //status=13
    end //L3>5
    if(status==1) begin
    //if still one, all are independent
      if(L1<quad_bound && !(L2<quad_bound)) begin
       //#xaxb + xcxd + xe
        status = 7;    
      end
      else if(L1<quad_bound && (L2<quad_bound)) begin
       //#xa + xb + xcxd
         status = 4;   
      end
      else begin
      
        // #xaxb + xcxd + xexf
                status = 10;
                end
    end//if status 1
    //assign output based on case
    if(twelver==1'b1) begin
        status=12;
    end/*
    case(status) 
   
    1: begin assign solutions=out1; assign outputnum=1;end
    2: begin assign solutions=out2; assign outputnum=2; end
    3: begin assign solutions=out3; assign outputnum=3; end
    4: begin assign solutions=out4; assign outputnum=4;end
    5: begin assign solutions=out5; assign outputnum=5;end
    6: begin assign solutions=out6; assign outputnum=6;end
    7: begin assign solutions=out7; assign outputnum=7;end
    8: begin assign solutions=out8; assign outputnum=8;end
    9: begin assign solutions=out9; assign outputnum=9;end
   10: begin assign solutions=out10; assign outputnum=10;end
   11: begin assign solutions=out11; assign outputnum=11;end
   12: begin assign solutions=out12; assign outputnum=12;end
   13: begin assign solutions=out13; assign outputnum=13;end
    endcase */
   end
    assign outputnum=status;
   
endmodule
