`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 02/20/2024 04:11:26 PM
// Design Name: 
// Module Name: three_to_two
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module three_to_two(
    input reg [6:0] code, 
    input reg RHS1, 
    input reg RHS2, 
    input reg rest, 
    input integer status,
    output solution, /* ??????????*/ 
    output integer xa        
);

//// TODO: WILL RECURSIVENESS WORK in veriliog ........./////

    /*
        * make cases to transform three differences to other solvable LUTs 

        @param code: the rest + the differences of the equations
        @param RHS1: the right hand side value of equation 1
        @param RHS2: the right hand side value of equation 2
        @param rest: predetermined rest value 0/1
        @param status: status of the equation, determine which LUT to use 

        return: xa, rest of sol

        @output solution: 
        @output xa: -1, no solution
    */

    /******* initialization of local variables *********/ 

    /*** output for LUT tables ***/
    wire [1:0] out_LUT_one; 
    wire [16:0] out_LUT_two;            /* Output: 00000 1 output */ 
    wire [14:0] out_LUT_three;
    wire nR2; 
    wire Z_LUT_one;                     /* LUT one type */
    wire [2:0] types;                   /* LUT two types */ 
    wire [5:0] Z1_LUT_two; 
    wire [3:0] Z2_LUT_twos;

    /*** coefficient codes for LUT ***/
    wire [4:0] code_LUT_one;            /* LUT one needs 5 bit coefficents  */
    wire [6:0] code_LUT_two;            /* LUT two needs 7 bit coefficients */
    wire 
    integer i;                         /* for loop var :P, i is the assumed value, used to determine xa=0 or xa=1 */

    // arbitrary_rest1 = rest             // the rest technically equal each other and it is decided before this in the for loop
    // arbitrary_rest2 = rest

   

always@(*) begin 

    xa = -1;                            // set xa to zero, as we always assume the zero solutions first 

    case(status)
        1:
            begin 
            /* Use LUT 3 to match new code */
            case_3_1(code, out_LUT_three);

            /* check output to see if new code is provided */
            if (out_LUT_three != 15'b0) begin
                //i is the assumed value, used to determine xa=0 or xa=1 in this 

                /*** rewriting Python for Verilog ***/ 

                for(i = 0; i <2; i = i+1) begin

                    /* check first assumed value, xa = 0 */
                    //TODO process to get correct output 
                    case(i)
                        0: code_LUT_two = {out_LUT_three[5:0], RHS1, RHS2};               // obtain new code; need to translate
                        1: begin
                            //TODO obtain new code when xa = 1  
                            RHS_REST(RHS1, RHS2, rest, out_LUT_three[5:0], out_LUT_three[5:0], out_LUT_three[5:0], 1'b1, nR1, nRHS1, nRHS2); 

                            code_LUT_two = {nR1, out_LUT_three[9:6], nRHS1, nRHS2};  //TODO     { (nR1), eq, (RHS1), (RHS2) }; 
                        end    
                    endcase

                    LUT2_TwoCoeffMap(code_LUT_two, out_LUT_two,types);          //obtain solution for new code

                    // exit the for loop if valid solution is found
                    if (out_LUT_two != 17'b0) begin
                        break;
                    end
            end
            end
            end 
        2:
            begin
            case_3_2(code, out_LUT_three); 

            if (out_LUT_three != 15'b0) begin 

                
                for(i = 0; i <2; i = i+1) begin

                    case(i)
                        0: code_LUT_one = {}; //new_code = (because_it_is(out, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i))
                        1: begin
                            RHS_REST(); 
                            code_LUT_one = {}; 
                        end 
                    endcase

                    LUT_ONE_COEFF(code_LUT_one, out_LUT_one, Z_LUT_one);

                    if (out_LUT_one != 17'b0) begin 
                        break; 
                    end 
                end 
            end 

            end 
           
        3:
            begin
            case_3_3(code, out_LUT_three);

            if (out_LUT_three != 15'b0) begin 

                for(i = 0; i <2; i = i+1) begin

                    new_code = (because_it_is(out, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i));

                    // xa = 0
                    if (i == 0) begin
                        LUT_ONE_COEFF(code_LUT_one, out_LUT_one, Z_LUT_one);
                    end else begin
                    // xa = 1 
                        LUT_2.two_coeff_map.get(new_code);
                    end 

                    if (sol != None) begin
                        // break
                        break;
                    end 

                end 
            end 
            end
        4:
            begin
            case_3_4(code, out_LUT_three);
            if (out_LUT_three != 15'b0) begin 

                 
                for(i = 0; i <2; i = i+1) begin   
                   
                    //TODO new_code = (because_it_is(out, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i))    
                    case(i)
                        0: code_LUT_two = {out_LUT_three[5:0], RHS1, RHS2};               // obtain new code; need to translate
                        1: begin
                            //TODO obtain new code when xa = 1  
                            RHS_REST(RHS1, RHS2, rest, out_LUT_three[5:0], out_LUT_three[5:0], out_LUT_three[5:0], 1'b1, nR1, nRHS1, nRHS2); 

                            code_LUT_two = {nR1, out_LUT_three[9:6], nRHS1, nRHS2};  //TODO     { (nR1), eq, (RHS1), (RHS2) }; 
                        end    
                    endcase
                    
                    LUT2_two_linear_quad_independent(new_code);

                    if (sol != None) begin
                        // break
                        break;
                    end 
                end

            end
            end
        5:
            begin
            case_3_5(code, out_LUT_three);
            if (out_LUT_three != 15'b0) begin 
                // when xa = 0, it doesn't provide anything usesful, like me
                i = 1;
                //new_code = (because_it_is(out, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,1))
                code_LUT_two = {}; 
                LUT2_TwoCoeffMap(code_LUT_two, out_LUT_two,types);
            end
            end
        6:
            begin
            case_3_6(code, out_LUT_three);
            if (out_LUT_three != 15'b0) begin 

                
                for(i = 0; i <2; i = i+1) begin  
                    new_code = (because_it_is(out, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i));

                    // xa = 0
                    if (i == 0) begin
                        LUT_ONE_QUAD(code_LUT_one, out_LUT_one, Z_LUT_one);
                    // xa = 1 
                    end else begin 
                        LUT2_TwoLinearQuadInd(code_LUT_two, out_LUT_two,types);
                    end 

                    if (sol != None) begin
                        // break
                        break;
                    end 
                end

            end
            end
        7:
            begin
            // transformed_eq = LUT_3.case_3_7.get(code, -1)
            case_3_7(code, out_LUT_three);
            if (out_LUT_three != 15'b0) begin
                for(i = 0; i <2; i = i+1) begin        
                    new_code = (because_it_is(out, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i));
                    // xa = 0, xa = 1 
                    LUT2_two_quad_independent(new_code);
                    if (out_LUT_two != None) begin
                        break;
                    end 
                end

            end
            end
        8:
            begin
            case_3_8(code, out_LUT_three);  
            if (out_LUT_three != 15'b0) begin 
                i = 1;
                // only get equation associated with xa = 1, no need to use new_code
                eq = out[0][0];
                // transformed equation status is 1 
                three_to_two(eq, RHS1, RHS2, rest, 1); ///////////OH BOI HERE IS RECURSIVENESS
            end 
            end          
        9:
            begin
            case_3_9(code, out_LUT_three);
            if (out_LUT_three != 15'b0) begin

                
                for(i = 0; i <2; i = i+1) begin       
                    new_code = (because_it_is(out, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i));
                    // xa = 0
                    if (i == 0) begin
                        LUT_ONE_QUAD(code_LUT_one, out_LUT_one, Z_LUT_one);
                    // xa = 1 
                    end else begin
                        //TODO check if its correct RECURSIVe
                        new_code = transformed_eq[0][0];
                        three_to_two(new_code, RHS1, RHS2, rest, 4);
                    end
                    if (sol != None) begin
                        break;
                    end
                end

            end 
            end
        10:
            begin
            case_3_10(code, out_LUT_three);
            if (out_LUT_three != 15'b0) begin

                
                for(i = 0; i <2; i = i+1) begin    
                    new_code = (because_it_is(transformed_eq, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i));
                    // xa = 0
                    if (i == 0) begin
                        LUT_2.two_quad_independent.get(new_code);
                    // xa = 1 
                    end else begin
                        new_code = transformed_eq[0][0];
                        three_to_two(new_code, RHS1, RHS2, rest, 7) ;
                        // sol = LUT_3.case_3_7.get(new_code)
                    end

                    if (sol != None) begin
                        break;
                    end
                end

            end
            end
        11:
            begin
            case_3_11(code, out_LUT_three);
            if (out_LUT_three != 15'b0) begin 

                
                for(i = 0; i <2; i = i+1) begin     
                    new_code = (because_it_is(transformed_eq, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i));
                    // xa = 0
                    if (i == 0) begin 
                        LUT_ONE_QUAD(code_LUT_one, out_LUT_one, Z_LUT_one);
                    // xa = 1 
                    end else begin
                        new_code = transformed_eq[0][0];
                        sol = three_to_two(new_code, RHS1, RHS2, rest, 2);
                        // sol = LUT_3.case_3_2.get(new_code)
                    end 

                    if (sol != None) begin
                        break;
                    end
                end

            end 
            end
        12:
            begin
            case_3_12(code, out_LUT_three);

            if (out_LUT_three != 15'b0) begin 

                
                for(i = 0; i <2; i = i+1) begin         
                    new_code = (because_it_is(transformed_eq, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i));
                    // xa = 0
                    if (i == 0) begin
                        LUT_ONE_QUAD(code_LUT_one, out_LUT_one, Z_LUT_one);
                    // xa = 1 
                    end else begin
                        // it goes into recursive because it didnt really simplfy to anything
                        new_code = transformed_eq[0][0];
                        sol = three_to_two(new_code, RHS1, RHS2, rest, 3);
                        // sol = LUT_3.case_3_3.get(new_code)
                    end 

                    if (sol != None) begin
                        break;
                    end
                end

            end
            end
        13: 
            begin
            case_3_13(code, out_LUT_three);
            if (out_LUT_three != 15'b0) begin 
                
                
                for(i = 0; i <2; i = i+1) begin       
                    //new_code = (because_it_is(transformed_eq, RHS1, RHS2, arbitrary_rest1, arbitrary_rest2,i))
                    // xa = 0, xa = 1 

                    LUT2_two_quad_dependent(new_code);

                    if (out_LUT_two != None) begin
                        break;
                    end
                end

            end
            end
        endcase 
        //////what is this
    if (sol) begin
       // return // [(None, None)]
    end
    // returns xa, rest of sol
    // return [(i,sol)]
end 

// abstracting 3_to_2 so that the switch statement doesnt look like a cry for help
// only going to take xa = 1

    // form new code
    // cruel_summer = { (nR1), eq, (RHS1), (RHS2) }; 



endmodule
