module LUT_ONE_QUAD(
    input [4:0] one_quad,
    output reg [1:0] out, 
    output reg Za   /* one quad answer */
); 

always @(*)  
begin 
Za = 1'b0; 
out = 2'b0;
    /* one_quad_map */
    case(one_quad)
    5'b01000: Za = 1'b1;
    5'b00100: Za = 1'b1;
    5'b01010: begin Za = 1'b0; out = 2'b11; end
    5'b00101: begin Za = 1'b0; out = 2'b11; end 
    5'b11011: Za = 1'b1;
    5'b10111: Za = 1'b1;
    default: ;
    endcase 
end 
endmodule