`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 02/20/2024 10:52:57 PM
// Design Name: 
// Module Name: case3_2
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module case3_2(
    input reg [6:0] coeff,
    output reg [6:0] out
); 

always@(*)
begin 
out = 7'b0; 
    case(coeff)
    7'b0000111, 7'b0111000:
        begin
            // (00,10,1),(001,0)
            out = 7'b0010001;
        end
    7'b0001110, 7'b0110001:
        begin
            // (01,11,1),(001,0)
            out = 7'b0111001;
        end
    7'b0010101, 7'b0101010:
        begin
            // (01,11,1),(010,0)
            out = 7'b0111010;
        end
    7'b0011100, 7'b0100011:
        begin
            // (00,10,1),(010,0)
            out = 7'b0010010;
        end
    7'b1000111, 7'b1111000:
        begin
            // (10,00,1),(101,0)
            out = 7'b1000101;
        end
    7'b1001110, 7'b1110001:
        begin
            // (11,01,1),(101,0)
            out = 7'b1101101;
        end
    7'b1010101, 7'b1101010:
        begin
            // (11,01,1),(110,0)
            out = 7'b1101110;
        end
    7'b1011100, 7'b1100011:
        begin
            // (10,00,1),(110,0)
            out = 7'b1000110;
        end
    endcase
end
endmodule  
