`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 02/06/2024 11:11:29 AM
// Design Name: 
// Module Name: sol_varying_one
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module sol_varying_one#(parameter integer EQ_LEN=34, parameter integer NUM_EQs=5, parameter integer window=34)(
input reg [EQ_LEN:0] matrixs [0:2],
integer location,
integer first,
integer second,
output reg [2:0] solutions
    );
    /* matrixs[0][30]);
    For when equations are different by one
    input: 2xEQLEN matrix that contains the 2 differeing eqs
    location is which variables are different 
    first is the number of the first equation in the matrix 
    second is the number of the other equation in the matrix
    output is solutions 
    
    Checking for which type is not yet correct
    */
    
    reg [EQ_LEN:0] eq1;
    reg [EQ_LEN:0] eq2;
    reg RHS2;
    reg RHS1;
    reg rest;
    reg eq1co;
    reg eq2co;
    reg one_coeff;
    reg quad_coeff;
    reg [4:0] coeffs; //2 coeffs, rest, 2 RHS
    reg [1:0] outputs;
    integer upper_bound=7;
    //have to call table modules before loop
    LUT_ONE_COEFF i(coeffs, one_coeff);
    LUT_ONE_QUAD test2(.one_quad(coeffs),.out(outputs), .Z(quad_coeff));
    always @(*) begin
    //assigning values
   eq1=matrixs[first];
   eq2=matrixs[second];
   eq1co=eq1[location];
   eq2co=eq2[location];
   RHS2=eq2[0];
   RHS1=eq1[0];
   rest=1'b1;
   coeffs={eq1co, eq2co,RHS1, RHS2, rest};
    solutions=3'd0;
      if(location<=upper_bound) begin //one coeff
       //if the differing variables are linear
       solutions[0]=one_coeff;
      // multiple_sol+=4;
      end
    else if(location>upper_bound) begin //quad case
      solutions[2]=quad_coeff;
      solutions[1:0]=outputs;
      //multiple_sol+=2;
    
     
  
    end
    end
endmodule


